#line 9 "macros.m4"

#line 1 "des3-test.m4"
#include "des.h"


#line 3
#include "testutils.h"
#line 3

#line 3
#include <string.h>
#line 3
#include <stdlib.h>
#line 3

#line 3
int main (int argc, char **argv)
#line 3
{
#line 3


struct des3_ctx ctx;

uint8_t msg[DES3_BLOCK_SIZE] = "Now is t";
uint8_t cipher[DES3_BLOCK_SIZE];
uint8_t clear[DES3_BLOCK_SIZE];

#line 14
/* Intermediate values:
#line 14
 *   After first DES encryption:  "cd ea 2a 20 c2 e0 9e 48"
#line 14
 *   After second DES decryption: "69 52 6e 95 8b ea 49 bd"
#line 14
 */
if (!des3_set_key(&ctx, decode_hex_dup("3e 0b 10 b0 5d 49 c2 54"
#line 17
			  "6b 46 e0 75 8a 91 61 85"
#line 17
			  "cb 04 07 d3 20 16 cb a2")))
  abort();

des3_encrypt(&ctx, DES_BLOCK_SIZE, cipher, msg);

if (!(!memcmp (cipher, decode_hex_dup("0a 5d b5 2d 85 74 d1 c9"), DES_BLOCK_SIZE)))
#line 24
  abort();

des3_decrypt(&ctx, DES_BLOCK_SIZE, clear, cipher);
if (!(!memcmp (msg, clear, DES_BLOCK_SIZE)))
  abort();
#line 5 "macros.m4"
  /* Avoid warnings for argc and argv unused */
  (void) argc; (void) argv;
  return 0;
}
